/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import com.rjconsultores.ventaboletos.entidad.FormaPagoDet;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderConfiguracionFormasPago;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 * 
 * @author Administrador
 */
@Controller("busquedaConfiguracionFormaPagoController")
@Scope("prototype")
public class BusquedaConfiguracionFormaPagoController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<FormaPagoDet> plwConfigFormaPago;
	private MyListbox configFormaPagoList;
	private Paging pagingConfigFormaPago;
	private Textbox txtNome;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		configFormaPagoList.setItemRenderer(new RenderConfiguracionFormasPago());
		configFormaPagoList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				FormaPagoDet fpd = (FormaPagoDet) configFormaPagoList.getSelected();
				verConfigFormaPago(fpd);
			}
		});

		refreshLista();

		txtNome.focus();
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	private void verConfigFormaPago(FormaPagoDet fpd) {
		if (fpd == null) {
			return;
		}

		Map args = new HashMap();
		args.put("formaPagoDet", fpd);
		args.put("configFormaPagoList", configFormaPagoList);

		openWindow("/gui/configuraciones_comerciales/editarConfiguracionFormaPago.zul",
				Labels.getLabel("editarConfiguracionFormaPagoController.window.title"), args, MODAL);
	}

	private void refreshLista() {
		HibernateSearchObject<FormaPagoDet> configFormaPagoBusqueda =
				new HibernateSearchObject<FormaPagoDet>(FormaPagoDet.class, pagingConfigFormaPago.getPageSize());

		configFormaPagoBusqueda.addFilterLike("formaPago.descpago", "%" + txtNome.getText().trim().concat("%"));

		configFormaPagoBusqueda.addSortAsc("formaPago.descpago");
		configFormaPagoBusqueda.addFilterEqual("activo", Boolean.TRUE);

		plwConfigFormaPago.init(configFormaPagoBusqueda, configFormaPagoList, pagingConfigFormaPago);

		if (configFormaPagoList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("busquedaConfiguracionFormaPagoController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}

	public void onClick$btnPesquisa(Event ev) {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verConfigFormaPago(new FormaPagoDet());
	}
}
